package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLAffList_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLAffList extends JNIObject  {
	
	/* @generated */
	protected ISLAffList(long ptr) {
		/*** PROTECTED REGION ID(ISLAffList_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLAffList build(long ptr) {
		return new ISLAffList(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLAffList_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_aff_list_alloc 
	 * 
	 * @generated
	**/
	 public static ISLAffList build(ISLContext ctx, int n) { 
		/*** PROTECTED REGION ID(static_isl_aff_list_alloc) DISABLED START ***/
		ISLAffList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLAffList.build(ISLNative.isl_aff_list_alloc(getNativePtr(ctx), n));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_list_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLAffList afflist, int format) { 
		/*** PROTECTED REGION ID(static_isl_aff_list_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_aff_list_to_string(getNativePtr(afflist), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_aff_list_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_aff_list_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_aff_list_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_list_copy 
	 * 
	 * @generated
	**/
	public ISLAffList copy() {
		/*** PROTECTED REGION ID(isl_aff_list_copy) DISABLED START ***/
		ISLAffList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLAffList.build(ISLNative.isl_aff_list_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_list_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_aff_list_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_aff_list_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_list_n_aff 
	 * 
	 * @generated
	**/
	public int getNbAffs() {
		/*** PROTECTED REGION ID(isl_aff_list_n_aff) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_aff_list_n_aff(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_list_get_aff 
	 * 
	 * @generated
	**/
	public ISLAff get(int index) {
		/*** PROTECTED REGION ID(isl_aff_list_get_aff) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLAff.build(ISLNative.isl_aff_list_get_aff(getNativePtr(this), index));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_list_set_aff 
	 * 
	 * @take this aff
	 * @generated
	**/
	public ISLAffList set(int index, ISLAff aff) {
		/*** PROTECTED REGION ID(isl_aff_list_set_aff) DISABLED START ***/
		ISLAffList res;
		
		synchronized(LOCK) {
			checkParameters(this, aff);
			try {
				res = ISLAffList.build(ISLNative.isl_aff_list_set_aff(getNativePtr(this), index, getNativePtr(aff)));
			} finally {
				taken(this);
				taken(aff);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_list_insert 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLAffList insert(int pos, ISLAff el) {
		/*** PROTECTED REGION ID(isl_aff_list_insert) DISABLED START ***/
		ISLAffList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLAffList.build(ISLNative.isl_aff_list_insert(getNativePtr(this), pos, getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_list_add 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLAffList add(ISLAff el) {
		/*** PROTECTED REGION ID(isl_aff_list_add) DISABLED START ***/
		ISLAffList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLAffList.build(ISLNative.isl_aff_list_add(getNativePtr(this), getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_list_drop 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAffList drop(int first, int n) {
		/*** PROTECTED REGION ID(isl_aff_list_drop) DISABLED START ***/
		ISLAffList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAffList.build(ISLNative.isl_aff_list_drop(getNativePtr(this), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_list_concat 
	 * 
	 * @take this list2
	 * @generated
	**/
	public ISLAffList concat(ISLAffList list2) {
		/*** PROTECTED REGION ID(isl_aff_list_concat) DISABLED START ***/
		ISLAffList res;
		
		synchronized(LOCK) {
			checkParameters(this, list2);
			try {
				res = ISLAffList.build(ISLNative.isl_aff_list_concat(getNativePtr(this), getNativePtr(list2)));
			} finally {
				taken(this);
				taken(list2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLAffList_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
